/* 페이징 관련 변수 */
let noticeTotalCount   = 0;
let noticeTotalPages   = 0;

/*aggird*/
let noticeAgGridData = [];

let noticeSelectId = "";

/****************************************************************************
* 검색 날짜 설정
//(A:오늘, B:3일, C:7일, D:최근30일, E:최근90일, F:이번달, G:올해, H:지난주, I:지난달)
****************************************************************************/
function fn_noticeSetDate(param){
	if("A"==param){
		// 오늘
		let toDate = new Date();
		let year  = toDate.getFullYear();
		let month = toDate.getMonth() + 1;
		let day   = toDate.getDate();
		
		if(month < 10) month = "0" + month;
		if(day < 10) day = "0" + day;
		
		noticeSearchStartDate = year+'-'+month+'-'+day;
		noticeSearchEndDate   = year+'-'+month+'-'+day;
	}
	else if("B"==param){
		// 3일
		// 검색 종료일자
		let toDate = new Date();
		let year  = toDate.getFullYear();
		let month = toDate.getMonth() + 1;
		let day   = toDate.getDate();
		
		if(month < 10) month = "0" + month;
		if(day < 10) day = "0" + day;
		
		noticeSearchEndDate   = year+'-'+month+'-'+day;
		
		// 검색 시작일자
		toDate.setDate(toDate.getDate() - 3);
		year  = toDate.getFullYear();
		month = toDate.getMonth() + 1;
		day   = toDate.getDate();
		
		if(month < 10) month = "0" + month;
		if(day < 10) day = "0" + day;
		
		noticeSearchStartDate = year+'-'+month+'-'+day;
	}
	else if("C"==param){
		// 이번주
		// 검색 종료일자
		let toDate = new Date();
		let year  = toDate.getFullYear();
		let month = toDate.getMonth() + 1;
		let day   = toDate.getDate();
		
		if(month < 10) month = "0" + month;
		if(day < 10) day = "0" + day;
		
		noticeSearchEndDate   = year+'-'+month+'-'+day;
		
		// 검색 시작일자
		toDate.setDate(toDate.getDate() - 7);
		year  = toDate.getFullYear();
		month = toDate.getMonth() + 1;
		day   = toDate.getDate();
		
		if(month < 10) month = "0" + month;
		if(day < 10) day = "0" + day;
		
		noticeSearchStartDate = year+'-'+month+'-'+day;
	}
	else if("D"==param){
		// 최근30일
		let toDate = new Date();
		let year  = toDate.getFullYear();
		let month = toDate.getMonth() + 1;
		let day   = toDate.getDate();
		
		if(month < 10) month = "0" + month;
		if(day < 10) day = "0" + day;
		
		//최근30일
		toDate.setDate(toDate.getDate() - 30);
		startYear  = toDate.getFullYear();
		startMonth = toDate.getMonth() + 1;
		startDay   = toDate.getDate();
		
		if(startMonth < 10) startMonth = "0" + startMonth;
		if(startDay < 10) startDay = "0" + startDay;
		
		noticeSearchStartDate = startYear+'-'+startMonth+'-'+startDay;
		noticeSearchEndDate   = year+'-'+month+'-'+day;
		
	}
	else if("E"==param){
		// 최근90일
		// 검색 종료일자
		let toDate = new Date();
		let year  = toDate.getFullYear();
		let month = toDate.getMonth() + 1;
		let day   = toDate.getDate();
		
		if(month < 10) month = "0" + month;
		if(day < 10) day = "0" + day;
		
		noticeSearchEndDate   = year+'-'+month+'-'+day;
		
		// 검색 시작일자
		toDate.setDate(toDate.getDate() - 90);
		year  = toDate.getFullYear();
		month = toDate.getMonth() + 1;
		day   = toDate.getDate();
		
		if(month < 10) month = "0" + month;
		if(day < 10) day = "0" + day;
		
		noticeSearchStartDate = year+'-'+month+'-'+day;
	}
	else if("F"==param){
		//F:이번달
		// 검색 종료일자
		let toDate = new Date();
		let year  = toDate.getFullYear();
		let month = toDate.getMonth() + 1;
		let day   = toDate.getDate();
		
		if(month < 10) month = "0" + month;
		if(day < 10) day = "0" + day;
		
		noticeSearchEndDate   = year+'-'+month+'-'+day;
		
		// 검색 시작일자
		noticeSearchStartDate = year+'-'+month+'-01';
	}
	else if("G"==param){
		// G:올해
		// 검색 종료일자
		let toDate = new Date();
		let year  = toDate.getFullYear();
		let month = toDate.getMonth() + 1;
		let day   = toDate.getDate();
		
		if(month < 10) month = "0" + month;
		if(day < 10) day = "0" + day;
		
		noticeSearchEndDate   = year+'-'+month+'-'+day;
		
		// 검색 시작일자
		noticeSearchStartDate = year+'-01-01';
	}
	else if("H"==param){
		// H:지난주, I:지난달
		// 검색 종료일자
		let toDate = new Date();
		let year  = toDate.getFullYear();
		let month = toDate.getMonth() + 1;
		let day   = toDate.getDate();
		
		if(month < 10) month = "0" + month;
		if(day < 10) day = "0" + day;
		
		noticeSearchEndDate   = year+'-'+month+'-'+day;
		
		// 검색 시작일자
		noticeSearchStartDate = year+'-01-01';
	}
	else if("I"==param){
		// I:지난달
		// 검색 종료일자
		let toDate = new Date();
		let year  = toDate.getFullYear();
		let month = toDate.getMonth() + 1;
		let day   = toDate.getDate();
		
		if(month < 10) month = "0" + month;
		if(day < 10) day = "0" + day;
		
		noticeSearchEndDate   = year+'-'+month+'-'+day;
		
		// 검색 시작일자
		noticeSearchStartDate = year+'-01-01';
	}
	
	$("#noticeSearchStartDate").val(noticeSearchStartDate).trigger("change");
	$("#noticeSearchEndDate").val(noticeSearchEndDate).trigger("change");
}


/****************************************************************************
* 공지사항 정보 리스트 조회
****************************************************************************/
function fn_selectListNoticeJson(){
	let formData = new FormData();
	formData.append("menuClass", menuClass);
	formData.append("noticeSearchKeywordParam", noticeSearchKeywordParam);
	formData.append("noticeSort", noticeSort);
	formData.append("noticeDir", noticeDir);
	formData.append("noticeStart", noticeStart);
	formData.append("noticeLimit", noticeLimit);
	formData.append("noticeSearchStartDate", noticeSearchStartDate);
	formData.append("noticeSearchEndDate", noticeSearchEndDate);
	formData.append("noticeSearchDateType", noticeSearchDateType);

	$.ajax({
		url: encodeURI('/webnotice/selectListNotice.do'),
		data: formData,
		dataType: "json",
		processData: false,
		contentType: false,
		type: 'POST',
		async: true,
		success: function(data){
			if('0'==data.msgCode){
				// 페이징 처리
				noticeTotalCount  = data.totalCount;
				//$("#txt_noticeTotalCount").text(noticeTotalCount);

				noticeTotalPages = Math.ceil(noticeTotalCount/noticeLimit);
				
				// 리스트 조회
				noticeAgGridData = data.rows;
				noticeGridOptions.api.setRowData(noticeAgGridData);
				
				if(0<data.rows.length){
					//페이징 처리
					window.pagObj = $('#noticePagination').twbsPagination({
						startPage    : ((noticeStart/noticeLimit)+1),
						totalPages   : (noticeTotalPages==0)?1:noticeTotalPages,
						visiblePages : 10,
						initiateStartPageClick: false,
						prev         : '<img src="/image/web/page_navigation_arrow.svg" alt="prev"/>',
						next         : '<img src="/image/web/page_navigation_arrow.svg" alt="next"/>',
						first        : '',
						last         : '',
						onPageClick: function (event, page) {
							fn_noticePagination(page);
						}
					}).on('page', function (event, page) {
						//console.info(page + ' (from event listening)');
					});
				}
				else{
					
				}
			}
			else{
				modalEvent.danger("조회 오류", data.msgDesc);
			}
		},
		error : function(xhr, status, error) {
			modalEvent.danger("조회 오류", "조회 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
		},
		beforeSend:function(){
			// 로딩열기
			noticeGridOptions.api.showLoadingOverlay();
		},
		complete:function(){
			
		}
	});
}

/****************************************************************************
* 검색하기
****************************************************************************/
function fn_noticeSearch(param){
	if("A"!=param && "Y"!=selectUseYn){
		modalEvent.warning("", "조회 권한이 없습니다.");
		return false;
	}
	
	fn_noticePaginReset();
	
	noticeSearchKeywordParam = $("#noticeSearchKeyword").val();

	noticeSearchDateType  = $("#noticeSearchDateType").val();
	noticeSearchStartDate = $("#noticeSearchStartDate").val();
	noticeSearchEndDate   = $("#noticeSearchEndDate").val();

	fn_selectListNoticeJson();
}


/****************************************************************************
* 초기화하기
****************************************************************************/
function fn_noticeReset(){
	fn_noticeSetDate('D');
	$("#noticeSearchDateType option:eq(0)").prop("selected", true);
	
	$("#noticeSearchKeyword").val("");

	fn_noticeSearch();
}

/****************************************************************************
* 페이징 처리
****************************************************************************/
function fn_noticePagination(param){
	noticeStart = (parseInt(param)-1)*noticeLimit;
	
	fn_selectListNoticeJson();
}

/****************************************************************************
* 페이징 리셋
****************************************************************************/
function fn_noticePaginReset(){
	noticeSearchKeywordParam = '';

	noticeStart        = 0;
	noticeLimit        = 100;
	noticeTotalCount   = 0;
	noticeTotalPages   = 0;
	
	//페이징 초기화
	if($("#noticePagination").data("twbs-pagination")){
		$("#noticePagination").twbsPagination("destroy");
	}
}

/****************************************************************************
* 공지사항 삭제
****************************************************************************/
function fn_deleteNotice(){
	if("Y"!=deleteUseYn){
		modalEvent.warning("", "삭제 권한이 없습니다.");
		return false;
	}
	
	if(!noticeSelectId){
		modalEvent.warning("", "삭제할 대상을 선택하세요.");
		return false;
	}

	modalEvent.info("삭제", "선택한 공지사항 정보를 삭제하시겠습니까?", function(){
		let formData = new FormData();
		formData.append("menuClass", menuClass);
		formData.append("selectId", noticeSelectId);

		$.ajax({
			url: encodeURI('/webnotice/deleteNotice.do'),
			data: formData,
			dataType: "json",
			processData: false,
			contentType: false,
			type: 'POST',
			async: true,
			success: function(data){
				if('0'==data.msgCode){
					modalEvent.success("삭제 성공", data.msgDesc, function(){
						fn_noticeOk();
					});
				}
				else{
					modalEvent.danger("삭제 오류", data.msgDesc);
				}
			},
			error : function(xhr, status, error) {
				modalEvent.danger("삭제 오류", "삭제 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
			},
			beforeSend:function(){
				
			},
			complete:function(){
				
			}
		});
	});
}

/****************************************************************************
* 검색 엔터 이벤트
****************************************************************************/
function fn_noticeEnter(e){
	if(e.which){
		// 파이어폭스
		if(13 == e.which) {
			//로그인 액션 스크립트
			fn_noticeSearch();
		}
	}
	else{
		// 윈도우, 사파리, 크롬
		if(13 == event.keyCode) {
			//로그인 액션 스크립트
			fn_noticeSearch();
		}
	}
}

/****************************************************************************
* 정렬 이벤트
****************************************************************************/
function fn_alignEvent(param, param2){
	let align = "";
	
	if("A"==param){
		align = "오늘";
		
		fn_noticeSetDate('A');
	}
	else if("B"==param){
		align = "최근30일";
		
		fn_noticeSetDate('D');
	}
	else if("C"==param){
		align = "최근90일";
		
		fn_noticeSetDate('E');
	}
	else if("D"==param){
		align = "이번주";
		
		fn_noticeSetDate('C');
	}
	else if("E"==param){
		align = "이번달";
		
		fn_noticeSetDate('F');
	}
	else if("F"==param){
		align = "올해";
		
		fn_noticeSetDate('G');
	}
	else if("G"==param){
		align = "지난주";
		
		fn_noticeSetDate('H');
	}
	else if("H"==param){
		align = "지난달";
		
		fn_noticeSetDate('I');
	}
	else{
		align = "";
	}
	$("#noticeSearchDateType").val(param);
	$("#noticeSearchDateType").siblings("button").text(align);
}

/****************************************************************************
* 완료
****************************************************************************/
function fn_noticeOk(){
	fn_noticeReset();
}

function fn_insertNoticePopup(){
	if("Y"!=insertUseYn){
		modalEvent.warning("", "등록 권한이 없습니다.");
		return false;
	}
	
	let reqParam =  {};
	noticeInsertModal.popup(function(obj, reqParam) {
		fn_noticeOk();
	}, reqParam);
}

function fn_updateNoticePopup(param){
	let reqParam =  {
		"muNoticeId" : param
	};
	
	if("Y"==updateUseYn){
		// 수정가능
		noticeUpdateModal.popup(function(obj, reqParam) {
			fn_noticeOk();
		}, reqParam);
	}
	else{
		// 조회만
		noticeSelectModal.popup(function(obj, reqParam) {
			fn_noticeOk();
		}, reqParam);
	}
	
}

let noticeColumnDefs = [
	{field: "checkbox", headerName:"", minWidth:55, maxWidth:55, headerCheckboxSelection: true, checkboxSelection: true},
	/* {field: "rowNum", headerName:"번호", minWidth:80,maxWidth:80, sortable: false}, */
	{field: "rowNum", headerName:"번호", minWidth:60,sortable: false, cellStyle:{textAlign: 'center'}},
	{field: "title", headerName:"제목", minWidth:250, maxWidth:250, cellStyle:{cursor: 'pointer', color:'#3985EA'}},
	{field: "content", headerName:"내용",minWidth:1011},
	{field: "openDate", headerName:"게시일",minWidth:100, maxWidth:100},
	{field: "writeName", headerName:"작성자",minWidth:100, maxWidth:100}
];

// let the grid know which columns and what data to use
let noticeGridOptions = {
	suppressRowTransform: true,
	columnDefs: noticeColumnDefs,
	defaultColDef: {		// 리스트 기본 설정
		flex: 1,
		sortable: true,		//정렬 여부
		resizable: true,	//리사이즈
		editable: true,	// 그리드에서 데이터 수정
		cellStyle:{textAlign:'left',fontSize:'14px',padding:'0'},
		//suppressSizeToFit:true,		//자동 맞춤
		//enableRowGroup: true,		// 그룹 묶음
		enablePivot: true,
		enableValue : true
	},
	//suppressMultiSort:true,  //단일솔트 true가 단일, false가 다중 shift + sort 시
	headerHeight : 41, // header 높이
	rowHeight : 41, // row 높이
	rowData : noticeAgGridData,
	suppressRowClickSelection : true, // 로우 클릭시 체크박스 선택 true no, false yes
	localeText : {
		noRowsToShow : '조회 결과가 없습니다.'
	}, //데이터 없을 시 나오는 문구
	rowSelection : 'multiple', // row 다중 선택
	debug : false,
	onCellClicked: function(event){ //셀 클릭 이벤트
		/* alert(event.column.colId); */
		if('title'==event.column.colId){
			fn_updateNoticePopup(event.data.muNoticeId);
		}
	},
	onSelectionChanged: function(event){ //체크박스 선택
		let selectRows = [];
		selectRows = event.api.getSelectedRows();
		
		noticeSelectId = '';
		for(let i=0; i<selectRows.length; i++){
			noticeSelectId += selectRows[i].muNoticeId + ",";
		}
		noticeSelectId = noticeSelectId.substring(0, noticeSelectId.lastIndexOf(','));
	},
	onSortChanged: function(event){
		 //정렬
		noticeSort = ''; //기존 정렬 초기화
		let columnArr = event.columnApi.getColumnState();
		if(0<columnArr.length){
			//sort index 순으로 재정렬
			columnArr.sort(function(a,b){
				return a.sortIndex - b.sortIndex;
			});
			
			let nullCnt = 0;
			for(let i=0; i<columnArr.length; i++){
				let gridSortModel = columnArr[i].colId;
				let gridSort = columnArr[i].sort;
				
				if(gridSort != null){
					noticeStart = 0;
					noticeSort += gridSortModel+' '+ gridSort + ',';
				}
				else{
					nullCnt++;
					if(nullCnt == columnArr.length){
						noticeSort = '';
						noticeDir = '';
						noticeStart = 0;
					}
				}
			}
		}
		noticeSort = noticeSort.substring(0,noticeSort.lastIndexOf( ",")); //맨끝 콤마 지우기

		fn_noticeSearch();
	}
};

// lookup the container we want the Grid to use
let noticeGridDiv = document.querySelector('#noticeGrid');

// create the grid passing in the div to use together with the columns & data we want to use
new agGrid.Grid(noticeGridDiv, noticeGridOptions);





/****************************************************************************
* 페이지 init
****************************************************************************/
function fn_pageInit(){
	// 날짜 datepicker
	fn_searchDatePicker("#divNoticeSearchStartDate", "#divNoticeSearchEndDate");
	
	if(!noticeSearchStartDate&&!noticeSearchEndDate){
		// 검색 오늘날짜 셋팅
		fn_noticeSetDate('D');
	}else{
		$("#noticeSearchStartDate").val(noticeSearchStartDate).trigger("change");;
		$("#noticeSearchEndDate").val(noticeSearchEndDate).trigger("change");;
	}
	
	// 초기 페이징 처리
	$("#noticeSearchKeyword").val(noticeSearchKeywordParam);
	
	fn_noticeSearch("A");
}

/****************************************************************************
* 페이지 event
****************************************************************************/
function fn_pageEvent(){
	// 검색 input
	$(document).on('keypress', '#noticeSearchKeyword', function(e) {
		fn_noticeEnter(e);
	});
	
	// 검색 조회 버튼
	$("#btnSearchNotice").click(function () {
		fn_noticeSearch();
	});
	
	// 공지사항 등록 팝업 버튼
	$("#btnInsertNotice").click(function () {
		fn_insertNoticePopup();
	});
	
	// 공지사항 삭제 버튼
	$("#btnDeleteNotice").click(function () {
		fn_deleteNotice();
	});
	
	// 기간 선택 콤보 이벤트
	const target = $("#noticeSearchDateType").siblings("ul.select_option_list");
	target.find("li.option_list_item").click(function () {
		let selectIdArr = $(this).prop("id").split('_');
		let selectId    = selectIdArr[1];
		let selectName  = $(this).text();
		
		$(this).parent().siblings("button").text(selectName);
		$(this).parent().siblings("input").val(selectId);
		
		fn_alignEvent(selectId);
	});
}

$(function(){
	// 페이지 init
	fn_pageInit();
	
	// 페이지 event
	fn_pageEvent();
});